"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeCertificate = void 0;
const env_paths_1 = __importDefault(require("env-paths"));
const node_opcua_client_1 = require("node-opcua-client");
const node_opcua_certificate_manager_1 = require("node-opcua-certificate-manager");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const os = __importStar(require("os"));
const paths = (0, env_paths_1.default)("opcua-commander");
function makeCertificate() {
    return __awaiter(this, void 0, void 0, function* () {
        const configFolder = paths.config;
        const pkiFolder = path.join(configFolder, "pki");
        const certificateManager = new node_opcua_certificate_manager_1.OPCUACertificateManager({
            rootFolder: pkiFolder
        });
        console.log("PKI Folder = ", pkiFolder);
        const clientCertificateManager = new node_opcua_certificate_manager_1.OPCUACertificateManager({
            rootFolder: pkiFolder,
            automaticallyAcceptUnknownCertificate: true,
            name: "pki"
        });
        yield clientCertificateManager.initialize();
        const certificateFile = path.join(pkiFolder, "own/certs/opcua_commander_certificate.pem");
        const privateKeyFile = clientCertificateManager.privateKey;
        if (!fs.existsSync(privateKeyFile)) {
            throw new Error("Cannot find privateKeyFile " + privateKeyFile);
        }
        const applicationName = "OPCUA-COMMANDER";
        const applicationUri = (0, node_opcua_client_1.makeApplicationUrn)(os.hostname(), applicationName);
        if (!fs.existsSync(certificateFile)) {
            yield certificateManager.createSelfSignedCertificate({
                applicationUri,
                outputFile: certificateFile,
                subject: `/CN=${applicationName}/O=Sterfive;/L=France`,
                dns: [],
                // ip: [],
                startDate: new Date(),
                validity: 365 * 10,
            });
        }
        return { certificateFile, clientCertificateManager, applicationName, applicationUri };
    });
}
exports.makeCertificate = makeCertificate;
//# sourceMappingURL=make_certificate.js.map